#!/usr/bin/env ruby

$KCODE="e"

$strSoft="RHP 0.0.1"

require 'qte'
require 'qpe'

include Qte
include Qpe

class UEnv
  def initialize
  end
  def deviceName
    strDevice = ""
    fp = File.new("/proc/deviceinfo/product","r")
    fp.each do |line|
      strDevice = line
    end
    return strDevice
  end
  def getDesktopWidth
    QApplication.desktop.width
  end
  def getDesktopHeight
    QApplication.desktop.height
  end
  def vgaScreen?
    if getDesktopWidth == 640 or getDesktopHeight== 640 then
      true
    else
      false
    end
  end
  def largeScreen?
    vgaScreen?
  end
  def defaultDialogSize
    if largeScreen? then
      370
    else
      200
    end
  end
end

class HpCalc
  attr_accessor :x, :y, :z, :t
  attr_accessor :bIn, :bP, :bMacro
  def initialize
    @x = 0.0
    @y = 0.0
    @z = 0.0
    @t = 0.0
    @bIn = false
    @bP = false
    @bMacro = false
    @hE2M={ "+" => method(:ePlus), "-" => method(:eMinus), "*" => method(:eAsterisk), "/"=>method(:eSlash), "sqrt" => method(:eSqrt), "sq" => method(:eSq), "sin" => method(:eSin), "cos" => method(:eCos), "tan" => method(:eTan), "asin" => method(:eASin), "acos" => method(:eACos), "atan" => method(:eATan) }
  end
  def evalExp(astrExp)
    astrExp.each do |e|
      m=@hE2M[e]
      if m!=nil then
        m.call
      else
#TODO äץå
#TODO ǤʤХ顼
        pushUp(e.to_f)
      end
    end
  end

  def pushUp(r)
    @t = @z
    @z = @y
    @y = @x
    @x = r
  end
  def pullDown(r)
    @x = r
    @y = @z
    @z = @t
  end
  def ePlus
    pullDown(@y + @x)
  end
  def eMinus
    pullDown(@y - @x)
  end
  def eAsterisk
    pullDown(@y * @x)
  end
  def eSlash
    pullDown(@y / @x)
  end
  def eSin
    @x = Math.sin(@x)
  end
  def eCos
    @x = Math.cos(@x)
  end
  def eTan
    @x = Math.tan(@x)
  end
  def eASin
    @x = Math.asin(@x)
  end
  def eACos
    @x = Math.acos(@x)
  end
  def eATan
    @x = Math.atan(@x)
  end
  def eSqrt
    @x = Math.sqrt(@x)
  end
  def eSq
    @x *= @x
  end

end

class ULineEdit < QLineEdit
  def initialize(s,p)
    super(s,p)
    @hK2E={ Key_Plus => "+", Key_Minus => "-", Key_Asterisk => "*", Key_Slash => "/", Key_R => "+", Key_J => "*", Key_Comma => "/", Key_X => "sqrt", Key_Z => "sq", Key_S => "sin", Key_C => "cos", Key_T => "tan", Key_D => "asin", Key_V => "acos", Key_Y => "atan"}
    catchEvent
  end

  def startX
    c=$calc
    c.pushUp(0)
    c.bIn = true
    $lex.setMaxLength(16)
    $frmMain.showRegisters
    $lex.setText("")
  end
  
  def endX
    c=$calc
    c.x = $lex.text.data.to_f
    c.bIn = false
    c.bP = false
    $lex.setMaxLength(22)
    $frmMain.showRegisters
  end

  def keyPressEvent(e)
    k = e.key
#    p k
    c=$calc
    case k
    when Key_0,Key_1,Key_2,Key_3,Key_4,Key_5,Key_6,Key_6,Key_7,Key_8,Key_9
      unless c.bIn
        startX
      end
      e.accept
    when Key_BackSpace
      if c.bIn then
        if $lex.text.data[-1,1]=="." then
          c.bP=false
        end
        e.accept
      else
        c.x = 0.0
        $frmMain.showRegisters
        e.ignore
      end
    when Key_Period
      if c.bP then
        e.ignore
      else
        unless c.bIn
          startX
        end
        c.bP = true
        e.accept
      end
    when 4100
#     Key_Enter
      if c.bIn then
        endX
      else
        c.pushUp(c.x)
        $frmMain.showRegisters
      end
      e.ignore
    when Key_NumLock
      e.accept
    else
      if c.bIn then
        endX
      end
      strMethod=@hK2E[k]
      if strMethod!=nil then
        c.evalExp([strMethod])
        $frmMain.showRegisters
      end
      e.ignore
    end
  end

end

class FormMain < QMainWindow
  def initialize
    super
    setCaption($strSoft)
    hb=QHBox.new(self)
    setCentralWidget(hb)
      vbl=QVBox.new(hb)
        h=QHBox.new(vbl)
          QLabel.new("T:",h)
          @let = QLineEdit.new("",h)
          @let.setFont(QFont.new("lcfont",36))
          @let.setReadOnly(true)
          @let.setMaxLength(22)
          @let.setEnabled(false)

        h=QHBox.new(vbl)
          QLabel.new("Z:",h)
          @lez = QLineEdit.new("",h)
          @lez.setFont(QFont.new("lcfont",36))
          @lez.setReadOnly(true)
          @lez.setMaxLength(22)
          @lez.setEnabled(false)

        h=QHBox.new(vbl)
          QLabel.new("Y:",h)
          @ley = QLineEdit.new("",h)
          @ley.setFont(QFont.new("lcfont",36))
          @ley.setReadOnly(true)
          @ley.setMaxLength(22)
          @ley.setEnabled(false)

        h=QHBox.new(vbl)
          QLabel.new("X:",h)
          @lex = ULineEdit.new("",h)
          @lex.setFont(QFont.new("lcfont",36))
          @lex.setMaxLength(22)
          $lex = @lex
          $lex.setFocus

        QLabel.new("s:sin  c:cos  t:tan  x:sqrt\nd:asin v:acos y:atan z:x^2\n\n\n\n\n\n\n\n",vbl)
#TODO 
#        l.setAlignment(AlignCenter)

      vbr=QVBox.new(hb)
        vbr.setFixedWidth(200)
        l=QLabel.new($strSoft,vbr)

#TODO 
        l.setAlignment(AlignCenter)

    @pCont=nil

    @hMenuId=Hash.new
    @mbar=QMenuBar.new(self)
    @hPop=Hash.new

    ["ե"].each do |e|
      @hPop[e]=QPopupMenu.new
      @mbar.insertItem(tr(e),@hPop[e])
      connect(@hPop[e],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    end

    p=@hPop["ե"]
    @hMenuId["version"]=p.insertItem(tr("С"))
#    p.setAccel(QAccel::stringToKey("Ctrl+V"),@hMenuId["version"])

    showRegisters

    catchEvent
  end

  def activateMenu(id)
    case id
    when @hMenuId["version"]
      QMessageBox::information(self, tr("С"), tr($strSoft), QMessageBox::Ok | QMessageBox::Default)
    end
  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def closeEvent(e)
    case QMessageBox::warning(self, tr("λƤ褤Ǥ"), tr("˽λƤǤ"), QMessageBox::Yes , QMessageBox::No)
    when QMessageBox::Yes
      e.accept
    when QMessageBox::No
      e.ignore
    end
  end

  def showRegisters
    c = $calc
    showRegister(@lex,c.x)
    showRegister(@ley,c.y)
    showRegister(@lez,c.z)
    showRegister(@let,c.t)
    @lex.setCursorPosition(0)
  end

  def showRegister(w,f)
    w.setText(f.to_s)
  end
end


a = QPEApplication.new([$0] + ARGV)

$env  = UEnv.new

if $env.largeScreen? then
  $iFont=18
else
  $iFont=10
end

QPEApplication.setFont(QFont.new("lcfont",$iFont))

a.setDefaultCodec(QTextCodec.codecForName("EUC-JP"))

#if FileTest.directory?("/home/zaurus/") then
#  $conf = RqrConf.new
#else
#  $conf = RqrConf.new("/home/root/Settings/rqr.conf")
#end

$calc=HpCalc.new

$frmMain = FormMain.new

a.showMainWidget($frmMain)
a.exec
